unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, EloTextBox, StdCtrls, ExtCtrls, ComCtrls, Menus, Buttons;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    FontDialog1: TFontDialog;
    Panel1: TPanel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    Splitter1: TSplitter;
    BitBtn5: TBitBtn;
    ComboBox1: TComboBox;
    Label2: TLabel;
    Edit1: TEdit;
    StatusBar1: TStatusBar;
    PopupMenu1: TPopupMenu;
    tttttttttttttttttttttt1: TMenuItem;
    yyyyyyyyyy1: TMenuItem;
    yyyyyyyyyyy1: TMenuItem;
    ComboBox2: TComboBox;
    Label3: TLabel;
    Edit2: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label4: TLabel;
    Label5: TLabel;
    BitBtn6: TBitBtn;
    Panel2: TPanel;
    EloTextBox1: TEloTextBox;
    Panel3: TPanel;
    BtnPosText1: TSpeedButton;
    BtnPosText2: TSpeedButton;
    BtnPosText3: TSpeedButton;
    BtnPosText4: TSpeedButton;
    BtnPosText5: TSpeedButton;
    BtnPosText6: TSpeedButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2Change(Sender: TObject);
    procedure Edit1Enter(Sender: TObject);
    procedure Edit2Enter(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure BtnPosText1Click(Sender: TObject);
    procedure BtnPosText2Click(Sender: TObject);
    procedure BtnPosText3Click(Sender: TObject);
    procedure BtnPosText4Click(Sender: TObject);
    procedure BtnPosText5Click(Sender: TObject);
    procedure BtnPosText6Click(Sender: TObject);
    procedure EloTextBox1Paint(Sender: TObject);
    procedure EloTextBox1VScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure EloTextBox1ErrorTextFormat(Sender: TObject; aCanvas: TCanvas;
      var aWord: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  FontDialog1.Font:= EloTextBox1.Font;
  if FontDialog1.Execute then EloTextBox1.Font:= FontDialog1.Font;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  EloTextBox1.Clear;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  EloTextBox1.FileName:= '';
  EloTextBox1.Strings.Assign(Memo1.Lines);
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
  EloTextBox1.FileName:= ExtractFilePath(Application.ExeName)+ 'ByWidth.txt';
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
  EloTextBox1.Strings.LoadFromFile(ExtractFilePath(Application.ExeName)+ 'ByWidth.txt');
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
  EloTextBox1.FileName:= '';
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
    0: EloTextBox1.AlignmentText:= atNone;
    1: EloTextBox1.AlignmentText:= atWidth;
    2: EloTextBox1.AlignmentText:= atWidthAndHyphen;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBox1Change(Self);
  Edit1.Text:= EloTextBox1.TabString;
  Edit2.Text:= IntToStr(EloTextBox1.Spacing);
  CheckBox1.Checked:= EloTextBox1.Enabled;
  CheckBox2.Checked:= EloTextBox1.HotTrack;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  EloTextBox1.TabString:= Edit1.Text;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  case ComboBox2.ItemIndex of        
    0: EloTextBox1.OEMConvert:= tcNone;
    1: EloTextBox1.OEMConvert:= tcOemToAnsi;
    2: EloTextBox1.OEMConvert:= tcAnsiToOem;
  end;
end;

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  if Key< #32 then exit;
  if (Key< '0') or (Key> '9') then Key:= #0;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  if Edit2.Text<> '' then EloTextBox1.Spacing:= StrToInt(Edit2.Text);
end;

procedure TForm1.Edit1Enter(Sender: TObject);
begin
  Edit1.Text:= EloTextBox1.TabString;
end;

procedure TForm1.Edit2Enter(Sender: TObject);
begin
  Edit2.Text:= IntToStr(EloTextBox1.Spacing);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  EloTextBox1.Enabled:= CheckBox1.Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  EloTextBox1.HotTrack:= CheckBox2.Checked;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  EloTextBox1.Invalidate;
end;

procedure TForm1.BtnPosText1Click(Sender: TObject);
begin
  EloTextBox1.TextHome;
end;

procedure TForm1.BtnPosText2Click(Sender: TObject);
begin
  EloTextBox1.TextPageUp;
end;

procedure TForm1.BtnPosText3Click(Sender: TObject);
begin
  EloTextBox1.TextPrior;
end;

procedure TForm1.BtnPosText4Click(Sender: TObject);
begin
  EloTextBox1.TextNext;
end;

procedure TForm1.BtnPosText5Click(Sender: TObject);
begin
  EloTextBox1.TextPageDown;
end;

procedure TForm1.BtnPosText6Click(Sender: TObject);
begin
  EloTextBox1.TextEnd;
end;

procedure TForm1.EloTextBox1Paint(Sender: TObject);
begin
  BtnPosText1.Enabled:= not EloTextBox1.BOFText;
  BtnPosText2.Enabled:= not EloTextBox1.BOFText;
  BtnPosText3.Enabled:= not EloTextBox1.BOFText;
  BtnPosText4.Enabled:= not EloTextBox1.EOFText;
  BtnPosText5.Enabled:= not EloTextBox1.EOFText;
  BtnPosText6.Enabled:= not EloTextBox1.EOFText;
end;

procedure TForm1.EloTextBox1VScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  Label1.Caption:= IntToStr(ScrollPos);
end;

procedure TForm1.EloTextBox1ErrorTextFormat(Sender: TObject; aCanvas: TCanvas;
  var aWord: String);
var
   strErr: String;
begin
  strErr:= ' It is long this word "'+ aWord+ '" too big.';
  if StatusBar1.SimpleText<> strErr then StatusBar1.SimpleText:= strErr;
end;

end.
